Gtk = imports.gi.Gtk
Gio = imports.gi.Gio

ExtensionUtils = imports.misc.extensionUtils
Ext = ExtensionUtils.getCurrentExtension();

init = ->

buildPrefsWidget = ->
  settings = ExtensionUtils.getSettings('org.gnome.shell.extensions.vertical-window-list')

  prefs = new Gtk.Grid (
    column_spacing: 12
    row_spacing: 12
  )

  title = new Gtk.Label(
    label: "<b>#{Ext.metadata.name} Preferences</b>"
    use_markup: true
    valign: Gtk.Align.CENTER
    hexpand: true
  )
  prefs.attach title, 0, 0, 2, 1


  # width
  widthLabel = new Gtk.Label(
    label: 'Panel width'
  )
  prefs.attach widthLabel, 0, 1, 1, 1

  width = new Gtk.Scale(
    orientation: Gtk.Orientation.HORIZONTAL
    draw_value: true
    digits: 0
  )
  width.set_range(10, 1000)
  prefs.attach width, 1, 1, 1, 1
  width.connect 'value-changed', -> settings.set_int('width', Math.floor(width.get_value()))
  settings.connect 'changed::width', -> width.set_value(settings.get_int('width'))
  settings.emit 'changed::width', ''


  # icon-size
  iconLabel = new Gtk.Label(
    label: 'Icon size'
  )
  prefs.attach iconLabel, 0, 2, 1, 1

  iconSize = new Gtk.Scale(
    orientation: Gtk.Orientation.HORIZONTAL
    draw_value: true
    digits: 0
  )
  iconSize.set_range(8, 256)
  prefs.attach iconSize, 1, 2, 1, 1
  iconSize.connect 'value-changed', -> settings.set_int('icon-size', Math.floor(iconSize.get_value()))
  settings.connect 'changed::icon-size', -> iconSize.set_value(settings.get_int('icon-size'))
  settings.emit 'changed::icon-size', ''

  # opacity
  opacityLabel = new Gtk.Label(
    label: 'Opacity'
  )
  prefs.attach opacityLabel, 0, 3, 1, 1

  opacity = new Gtk.Scale(
    orientation: Gtk.Orientation.HORIZONTAL
    draw_value: true
    digits: 0
  )
  opacity.set_range(0, 255)
  prefs.attach opacity, 1, 3, 1, 1
  opacity.connect 'value-changed', -> settings.set_int('panel-opacity', Math.floor(opacity.get_value()))
  settings.connect 'changed::panel-opacity', -> opacity.set_value(settings.get_int('panel-opacity'))
  settings.emit 'changed::panel-opacity', ''

  return prefs